Page MenuHomePhabricator

Mentorship: allow newcomers to opt-in and opt-out of mentorship
Open, In Progress, MediumPublic

Assigned To
Authored By
MMiller_WMF
Aug 2 2021, 10:39 PM
Referenced Files
F35137109: Screenshot_20220512-163107_Chrome.jpg
May 12 2022, 11:36 PM
F35137100: Screenshot_20220512-150459_Chrome.jpg
May 12 2022, 11:36 PM
F35137096: Screen Shot 2022-05-12 at 4.23.58 PM.png
May 12 2022, 11:36 PM
F35137089: Screenshot_20220512-150425_Chrome.jpg
May 12 2022, 11:36 PM
F35137111: Screen Shot 2022-05-12 at 4.33.29 PM.png
May 12 2022, 11:36 PM
F35136965: Screenshot_20220512-150340_Chrome.jpg
May 12 2022, 11:19 PM
F35137076: Screen Shot 2022-05-12 at 4.09.35 PM.png
May 12 2022, 11:19 PM
F35137080: Screen Shot 2022-05-12 at 4.14.25 PM.png
May 12 2022, 11:19 PM

Description

This task is about enabling newcomers to opt out of the mentor module. A feature to enable newcomers to choose specific mentors is described in T292068: Have a way for a mentee to select a new mentor and will be considered in future.

User Job Stories
As a newcomer who values privacy and does not want perceived scrutiny by others(privacy-conscious)
When Isee that I have been assigned an experienced editor as a mentor,(situation)
I want tobe able to be remove that mentor,(motivation)
so thatI feel free from personalised attention by someone to my activities on Wikipedia.(expected outcome)
As a newcomer who wants to be learn about Wikipedia on my own(no help wanted)
When Isee that I have been assigned an experienced editor as a mentor,(situation)
I want tobe able to be remove myself as a mentee,(motivation)
so thatI feel unmonitored and free to contribute uninhibitedly on Wikipedia.(expected outcome)
As a newcomer who does not expect or want unsolicited communications(unwanted messages)
When Iget an unsolicited and unwelcome message from my mentor asking about my Wikipedia activity(situation)
I want tobe able to block or stop further contact from this person as my mentor(motivation)
so thatI can continue using other newcomer features and contribute without seeing their messages.(expected outcome)

This third user story may necessitate a future feature that enables a newcomer to not only opt-out, but report or more actively block their mentor, tasked as T292629.

A supplementary benefit of this feature may be that mentors could get less irrelevant messages, per the following reason:
"As a mentor, I don't want to receive so many messages that don't contain substantive questions." Many newcomers send messages to their mentors that don't have actionable substance, the most common being "hello". It is debatable whether such conversation starters are actually a good thing for the newcomer experience, but we could experiment with whether requiring opt-in would screen out some of the newcomers who don't intend to ask substantial questions.

Proposed designs

1. Opting out

  • The newcomer may access the opt-out modal can be accessed via a new overflow menu item on the mentor module, or via a link in the “About mentors” dialog (also new, see T292627).
  • Upon selecting the "Opt out" button, they are shown a confirmation message.
  • We may wish to show an optional "why did you opt-out?" question on the second screen. If this is descoped, then it would simply contain the confirmation that the newcomer has opted out.
  • All copy is TBC.
  • Opting out will revert the mentor module to a new opted-out state of the Mentor module on Desktop, on Mobile, they will return to the newcomer homepage with the mentor preview module in a new opted out state (see below).

2. Opted out state of mentor module

  • The mentor module goes into this new state after the newcomer opts out of mentoring.
  • The Desktop module is as shown, with text and a quiet icon button to bring up the "opt-in" modal.
  • On mobile, there is a new opted out state for the mobile preview only, since there is no mobile mentor module. Selecting anywhere on the mentor preview will bring up the "opt-in" modal.
  • All copy is TBC.

Further notes on proposed designs:

  • Newcomer are default opted-in, but will have additional context/information provided about the feature (per T292627) and are given a clear CTA to opt out.
  • Opting-out will unassign and detach the newcomer from their mentor. This is so that the mentor will be prevented from reaching out to mentees who have opted-out. The mentee should be removed from the mentor's dashboard and from their ability to filter to them in Recent Changes.
  • If the newcomer opts back in, they should not receive the same mentor as before. We should randomly assign them a new mentor.

Related Objects

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

Can this be merged or linked with the existing ticket @MMiller_WMF please T278712?

I think we have two very separated issues into this task.

"As a newcomer, I don't want to have a mentor because I want to remain private."
Is it really relevant? All edits are public. I can already check all edits being made by all newcomers, just by filtering them down at Special:RecentChanges.

Maybe we should have a configuration step during the onboarding? "An experienced mentor will be assigned to you. This mentor will know that you exist, and could have a look at your (public) edits in order to check your contributions and provide you some advice. Do you want a mentor? [yes][no]".


"As a mentor, I don't want to receive so many messages that don't contain substantive questions."

We shouldn't forget that the quality of the questions is subjective, and varies from user to user. This being said, I agree on the fact that "hello" or "how are you" aren't substantive questions. :)

We tried to reinforce the quality of questions being asked in the Help panel by changing the placeholder: T243694: Help panel: change placeholder text. Maybe we should consider to change the Mentorship module placeholder as well.
"Say hello and ask your question." could become: "Hello, I need some help with editing. How can I..."

We should monitor the quality of the questions. We could take a random number fo questions from our pilot wikis and check if it is possible to respond to them, and if they are perceived as qualitative. I already did this, and most questions were perfectly actionable, but the few that weren't qualitative enough lead some users to conclude that "quite all questions are poor quality ones". A very humain behavior.

RHo renamed this task from Mentorship: allow users to opt-in and opt-out to Mentorship: allow newcomers to opt-in and opt-out of mentorship.Oct 6 2021, 12:10 PM
RHo triaged this task as High priority.
RHo updated the task description. (Show Details)

Adding my personal project to keep this at my radar.

@RHo I just checked your designs, and they're perfect, I like them :-). As soon as we're sure this is how we want it to look like, I'm happy to start working on this.

@RHo Can you please clarify whether this task should still be in "Design doing" (with you assigned to it), or if it is okay for me to work on this?

Hiya @Urbanecm_WMF - happy for you to get started if this is prioritised on the Mentor features work with @MMiller_WMF

Thanks @RHo! Clearing you as the assignee then.

Change 738614 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[mediawiki/extensions/GrowthExperiments@master] Rewrite MentorManager::isMentorshipEnabledForUser to tristate

https://gerrit.wikimedia.org/r/738614

MMiller_WMF lowered the priority of this task from High to Medium.Nov 16 2021, 1:32 AM

Change 739356 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[mediawiki/extensions/GrowthExperiments@master] Create ApiSetMenteeStatus

https://gerrit.wikimedia.org/r/739356

The message "MediaWiki:Growthexperiments-mentor-dashboard-mentee-overview-info-text" should indicate that non opt-out is required to explain any "missing" mentors perhaps.

Change 738614 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] Rewrite MentorManager::isMentorshipEnabledForUser to tristate

https://gerrit.wikimedia.org/r/738614

Change 739356 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] Create API to get/set mentee status

https://gerrit.wikimedia.org/r/739356

The message "MediaWiki:Growthexperiments-mentor-dashboard-mentee-overview-info-text" should indicate that non opt-out is required to explain any "missing" mentors perhaps.

To keep the archives happy, this is being fixed as part of T297261.

Urbanecm_WMF changed the task status from Open to In Progress.Jan 31 2022, 11:32 AM

Change 761484 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[mediawiki/extensions/WikimediaEvents@master] PrefUpdate: Track changes of growthexperiments-homepage-mentorship-enabled

https://gerrit.wikimedia.org/r/761484

Change 761484 merged by jenkins-bot:

[mediawiki/extensions/WikimediaEvents@master] PrefUpdate: Track changes of growthexperiments-homepage-mentorship-enabled

https://gerrit.wikimedia.org/r/761484

Change 761489 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[mediawiki/extensions/GrowthExperiments@master] WIP: Homepage: Let mentees enable mentorship after opting-out

https://gerrit.wikimedia.org/r/761489

Hello @RHo, can you please clarify what should happen after the user opts back into mentorship (ie. once they press the "Continue") button? I assume a confirmation screen should appear and then...a page refresh (to load the new "opt in" module)? Or is a refresh not acceptable?

Hello @RHo, can you please clarify what should happen after the user opts back into mentorship (ie. once they press the "Continue") button? I assume a confirmation screen should appear and then...a page refresh (to load the new "opt in" module)? Or is a refresh not acceptable?

And other question (that came up while discussing this with @Tgr): The designs for opting out of mentorship at F34678894 include a three dots menu in the mentorship module. Is it likely we will need that capability in other modules too? In other words, would it be worth the effort to implement that at the framework level (so any module can reuse it later)?

Hello @RHo, can you please clarify what should happen after the user opts back into mentorship (ie. once they press the "Continue") button? I assume a confirmation screen should appear and then...a page refresh (to load the new "opt in" module)? Or is a refresh not acceptable?

Hi @Urbanecm_WMF - I think we ideally should refresh the page immediately to show the mentor module (no confirmation step needed).

image.png (1×1 px, 202 KB)

And other question (that came up while discussing this with @Tgr): The designs for opting out of mentorship at F34678894 include a three dots menu in the mentorship module. Is it likely we will need that capability in other modules too? In other words, would it be worth the effort to implement that at the framework level (so any module can reuse it later)?

Yes, that's a great suggestion.

In here @Sunpriat notes:

(A) mentor can observe the contribution statistics and activity time for an unprecedented long time (even logged actions that are usually not observed by others) that the extension makes to him.

What we display on the dashboard is:

  • username and registration date
  • last activity
  • number of edits
  • number of questions to mentor
  • number of reverts
  • number of blocks

Almost all of this is visible in Logs and at Special:Contributions.

Change 779529 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[mediawiki/extensions/GrowthExperiments@master] [WIP] Homepage: Let mentees opt out from mentorship

https://gerrit.wikimedia.org/r/779529

Change 786268 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[schemas/event/secondary@master] homepagemodule: Add mentorship-optout action

https://gerrit.wikimedia.org/r/786268

Change 786279 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[mediawiki/extensions/GrowthExperiments@master] Homepage: Instrument re-enabling mentorship

https://gerrit.wikimedia.org/r/786279

Change 786268 merged by jenkins-bot:

[schemas/event/secondary@master] homepagemodule: Add mentorship-optout/mentorship-optin actions

https://gerrit.wikimedia.org/r/786268

Change 761489 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] Homepage: Let mentees re-enable mentorship after opting-out

https://gerrit.wikimedia.org/r/761489

Change 788318 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[mediawiki/extensions/GrowthExperiments@master] HomepageModule: bump schema version to 1.5.0

https://gerrit.wikimedia.org/r/788318

Change 786279 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] Homepage: Instrument re-enabling mentorship

https://gerrit.wikimedia.org/r/786279

Change 788318 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] HomepageModule: bump schema version to 1.5.0

https://gerrit.wikimedia.org/r/788318

Change 789927 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[mediawiki/extensions/GrowthExperiments@master] Mobile homepage: Let mentees opt out from mentorship

https://gerrit.wikimedia.org/r/789927

Change 779529 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] Homepage: Let mentees opt out from mentorship

https://gerrit.wikimedia.org/r/779529

Change 789927 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] Mobile homepage: Let mentees opt out from mentorship

https://gerrit.wikimedia.org/r/789927

Change 789934 had a related patch set uploaded (by Gergő Tisza; author: Gergő Tisza):

[mediawiki/extensions/GrowthExperiments@master] Mentorship: Redirect to homepage overview when opting in

https://gerrit.wikimedia.org/r/789934

Change 789934 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] Mentorship: Redirect to homepage overview when opting in

https://gerrit.wikimedia.org/r/789934

This should be ready for QA now. @Etonkovidova Noting this is supposed to be instrumented (as part of homepagemodule. actions mentorship-optout and mentorship-optin). I'm not sure if this is something you usually test as well -- let me know if not :).

For @RHo review
Mobile - Opting out (with comparison to the mockups)

(1) The initial screen

  • There is no text "We've assigned you ..."

Screenshot_20220512-150331_Chrome.jpg (2×1 px, 170 KB)

(2) The initial screen with the drop-won

  • the drop-down box is not right-centered
  • the grey state of the pressed three-dot button is only during the actual click
betalabsmockup
Screenshot_20220512-150340_Chrome.jpg (2×1 px, 192 KB)
Screen Shot 2022-05-12 at 3.33.07 PM.png (362×414 px, 31 KB)

(2) Opt-out dialog step 1

  • "Opt out of mentoring" is not bolded.
  • "You can always opt back into mentoring again.[...]" Possibly confusing phrasing here: A user is not opting out of being a mentor, but from being mentored. Users may returned to being mentored again (or to get a mentor again.
betalabsmockup
Screenshot_20220512-150350_Chrome.jpg (2×1 px, 226 KB)
Screen Shot 2022-05-12 at 4.09.35 PM.png (695×394 px, 70 KB)

(3) Opt-out dialog step 2

  • "You're no longer being mentored" is not bolded
  • no space before radio-button options
betalabsmockup
Screenshot_20220512-150359_Chrome.jpg (2×1 px, 291 KB)
Screen Shot 2022-05-12 at 4.14.25 PM.png (697×393 px, 66 KB)

For @RHo review:
Mobile - Opting in (with comparison to the mockups)
(1) Mobile preview

  • Mobile preview doesn't include "Get a mentor" link; clicking on the preview will display an overlay where the link is present.
  • Why mentor is in quotations marks?
betalabsmockup
Screenshot_20220512-150425_Chrome.jpg (2×1 px, 298 KB)
Screen Shot 2022-05-12 at 4.23.58 PM.png (243×395 px, 19 KB)
Screenshot_20220512-150459_Chrome.jpg (2×1 px, 155 KB)

(2) Opt-in dialog

  • "Get a mentor?" is not bolded
betalabsmockup
Screenshot_20220512-163107_Chrome.jpg (2×1 px, 225 KB)
Screen Shot 2022-05-12 at 4.33.29 PM.png (723×394 px, 59 KB)

Per discussion with @Trizek-WMF, this should have a tech news notice. This change will be deployed with the wmf.12 train (so this Thursday for Wikipedias).

Possible wording: The Growth team maintains a mentorship program for newcomers. Previously, newcomers weren't able to opt out from the program. Starting May 19, 2022, newcomers are able to fully opt out from Growth mentorship, in case they do not wish to have any mentor at all.

Hi @Urbanecm_WMF - thanks for your work so far. As @Etonkovidova picked up in QA, there are some differences in the mocks that I wanted to get fixed.

For @RHo review:
Mobile - Opting in (with comparison to the mockups)
(1) Mobile preview

  • Mobile preview doesn't include "Get a mentor" link; clicking on the preview will display an overlay where the link is ptresent.

On mobile, there should indeed be the "Get a mentor" quiet (frameless) progressive button with icon on the mobile preview. This is because selecting that should trigger the opt-in dialog over the mobile homepage (not take users to a mobile opted-out mentor module).

  • Why mentor is in quotations marks?

This is my draft copy because "mentor" is often an unfamiliar concept to users, we can change to remove the quotes.

betalabsmockup
Screenshot_20220512-150425_Chrome.jpg (2×1 px, 298 KB)
Screen Shot 2022-05-12 at 4.23.58 PM.png (243×395 px, 19 KB)
Screenshot_20220512-150459_Chrome.jpg (2×1 px, 155 KB)

(2) Opt-in dialog

  • "Get a mentor?" is not bolded
betalabsmockup
Screenshot_20220512-163107_Chrome.jpg (2×1 px, 225 KB)
Screen Shot 2022-05-12 at 4.33.29 PM.png (723×394 px, 59 KB)

Per previous comment, the intention is that the Opt-in dialog is triggered by tapping on the button in the mentor preview and appear over the homepage, rather than in a separate mobile view of the opted-out mentor module. And yes, "Get a mentor" is not actually a link but a progressive quiet button with icon in the same Accent50 colour.

Change 804736 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[mediawiki/extensions/GrowthExperiments@master] [i18n] Do not put "mentor" in quotation marks

https://gerrit.wikimedia.org/r/804736

Change 804736 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] [i18n] Do not put "mentor" in quotation marks

https://gerrit.wikimedia.org/r/804736

@Urbanecm_WMF , is this task still in progress, or should it be 'Resolved'?

@Urbanecm_WMF , is this task still in progress, or should it be 'Resolved'?

Hi, thanks for the reminder. @RHo's comments from T287915#7938222. I was trying to change the behavior to include the button in the mobile preview directly, but I didn't manage to find a way (sorry!). @kostajh, can you please help and point me to a way how I can do that? Thanks!

Change 810089 had a related patch set uploaded (by Kosta Harlan; author: Kosta Harlan):

[mediawiki/extensions/GrowthExperiments@master] Mentorship: Include opt-in button on mobile summary preview

https://gerrit.wikimedia.org/r/810089

Change 810089 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] Mentorship: Include opt-in button on mobile summary preview

https://gerrit.wikimedia.org/r/810089

@Urbanecm_WMF , is this task still in progress, or should it be 'Resolved'?

Hi, thanks for the reminder. @RHo's comments from T287915#7938222. I was trying to change the behavior to include the button in the mobile preview directly, but I didn't manage to find a way (sorry!). @kostajh, can you please help and point me to a way how I can do that? Thanks!

Thanks to @kostajh, (1) from T287915#7938222 is now fixed. I'm wondering whether we also need to address (2) -- the currently-present dialog is the standard OOUI dialog. We can probably hack it to look like in the mockup, but I'd like to avoid that if possible.